Index: /trunk/src/org/expeditee/io/flowlayout/XGroupItem.java
===================================================================
--- /trunk/src/org/expeditee/io/flowlayout/XGroupItem.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/flowlayout/XGroupItem.java	(revision 1102)
@@ -19,7 +19,4 @@
 package org.expeditee.io.flowlayout;
 
-import java.awt.Point;
-import java.awt.Polygon;
-import java.awt.Rectangle;
 import java.util.ArrayList;
 import java.util.Collection;
@@ -31,4 +28,7 @@
 import java.util.List;
 
+import org.expeditee.core.Point;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.core.bounds.PolygonBounds;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameUtils;
@@ -110,6 +110,5 @@
 	}
 
-	public XGroupItem(Frame frame, List<Item> y_ordered_items,
-			Polygon enclosing_polygon) {
+	public XGroupItem(Frame frame, List<Item> y_ordered_items, PolygonBounds enclosing_polygon) {
 		this.frame = frame;
 		this.out_of_flow = FlowType.in_flow;
@@ -124,5 +123,5 @@
 		}
 
-		Rectangle enclosing_bounding_rect = enclosing_polygon.getBounds();
+		AxisAlignedBoxBounds enclosing_bounding_rect = AxisAlignedBoxBounds.getEnclosing(enclosing_polygon);
 		initSpanArray(enclosing_bounding_rect);
 
@@ -134,6 +133,5 @@
 		remaining_item_list = new ArrayList<Item>();
 
-		separateYOverlappingItems(frame, y_ordered_items, enclosing_polygon,
-				raw_text_item_list, grouped_item_list, remaining_item_list);
+		separateYOverlappingItems(frame, y_ordered_items, enclosing_polygon, raw_text_item_list, grouped_item_list, remaining_item_list);
 
 		// Step 2: Add in the raw-text items
@@ -161,5 +159,6 @@
 	}
 
-	protected XGroupItem(XGroupItem imprint, Rectangle copy_to_bounding_rect) {
+	protected XGroupItem(XGroupItem imprint, AxisAlignedBoxBounds copy_to_bounding_rect)
+	{
 		super();
 
@@ -192,5 +191,5 @@
 												// straight away?
 
-		this.bounding_rect = new Rectangle(copy_to_bounding_rect); // deep copy
+		this.bounding_rect = new AxisAlignedBoxBounds(copy_to_bounding_rect); // deep copy
 																	// to be on
 																	// the safe
@@ -198,5 +197,5 @@
 	}
 
-	protected void initSpanArray(Rectangle bounding_rect) {
+	protected void initSpanArray(AxisAlignedBoxBounds bounding_rect) {
 		this.bounding_rect = bounding_rect;
 
@@ -533,6 +532,5 @@
 							// to make it appear where the start of the arrow is
 
-							Rectangle start_rect = start_item.getArea()
-									.getBounds();
+							AxisAlignedBoxBounds start_rect = start_item.getBoundingBox();
 
 							XGroupItem xgroup_item_shallow_copy = new XGroupItem(
@@ -630,6 +628,6 @@
 	 * @return
 	 */
-	public Collection<Item> getItemsInNestedEnclosure(Item given_item,
-			AreaPolygon outer_polygon) {
+	public Collection<Item> getItemsInNestedEnclosure(Item given_item, PolygonBounds outer_polygon)
+	{
 		Collection<Item> sameEnclosure = null;
 		Collection<Item> seen = new HashSet<Item>();
@@ -649,5 +647,5 @@
 				seen.addAll(i_enclosing_dots);
 
-				Polygon i_polygon = new Polygon();
+				PolygonBounds i_polygon = new PolygonBounds();
 				for (int di = 0; di < i_enclosing_dots.size(); di++) {
 					Item d = i_enclosing_dots.get(di);
@@ -684,5 +682,5 @@
 
 	public void separateYOverlappingItems(Frame frame, List<Item> item_list,
-			Polygon enclosing_polygon, List<Text> raw_text_item_list,
+			PolygonBounds enclosing_polygon, List<Text> raw_text_item_list,
 			List<XGroupItem> grouped_item_list, List<Item> remaining_item_list) {
 		final List<Item> origonal_item_list = new ArrayList<Item>(item_list);
@@ -692,7 +690,7 @@
 		// of lines/polylines/polygons
 
-		AreaPolygon area_enclosing_polygon = new AreaPolygon(enclosing_polygon);
-
-		List<AreaPolygon> area_enclosed_polygon_list = new ArrayList<AreaPolygon>();
+		PolygonBounds area_enclosing_polygon = new PolygonBounds(enclosing_polygon);
+
+		List<PolygonBounds> area_enclosed_polygon_list = new ArrayList<PolygonBounds>();
 
 		while (item_list.size() > 0) {
@@ -724,6 +722,5 @@
 								.remove(0); // shift
 
-						Polygon enclosed_polygon = enclosure_item
-								.getEnclosedShape();
+						PolygonBounds enclosed_polygon = enclosure_item.getEnclosedShape();
 
 						if (enclosed_polygon != null) {
@@ -739,8 +736,6 @@
 							// group)
 
-							AreaPolygon area_enclosed_polygon = new AreaPolygon(
-									enclosed_polygon);
-							area_enclosed_polygon_list
-									.add(area_enclosed_polygon);
+							PolygonBounds area_enclosed_polygon = new PolygonBounds(enclosed_polygon);
+							area_enclosed_polygon_list.add(area_enclosed_polygon);
 
 							item_list.remove(enclosure_item);
@@ -763,10 +758,7 @@
 							while (item_iterator.hasNext()) {
 								Item item_to_check = item_iterator.next();
-								Point pt_to_check = new Point(
-										item_to_check.getX(),
-										item_to_check.getY());
-
-								if (area_enclosed_polygon
-										.isPerimeterPoint(pt_to_check)) {
+								Point pt_to_check = new Point(item_to_check.getX(), item_to_check.getY());
+
+								if (area_enclosed_polygon.isVertex(pt_to_check)) {
 									items_on_perimeter.add(item_to_check);
 								}
@@ -801,7 +793,7 @@
 		// Sort areas, smallest to largest
 		Collections.sort(area_enclosed_polygon_list,
-				new Comparator<AreaPolygon>() {
-
-					public int compare(AreaPolygon ap1, AreaPolygon ap2) {
+				new Comparator<PolygonBounds>() {
+
+					public int compare(PolygonBounds ap1, PolygonBounds ap2) {
 						Double ap1_area = ap1.getArea();
 						Double ap2_area = ap2.getArea();
@@ -817,9 +809,9 @@
 			// ri = remove index pos
 
-			AreaPolygon rpoly = area_enclosed_polygon_list.get(ri);
+			PolygonBounds rpoly = area_enclosed_polygon_list.get(ri);
 
 			for (int ci = ri + 1; ci < area_enclosed_polygon_list.size(); ci++) {
 				// ci = check index pos
-				AreaPolygon cpoly = area_enclosed_polygon_list.get(ci);
+				PolygonBounds cpoly = area_enclosed_polygon_list.get(ci);
 				if (rpoly.completelyContains(cpoly)) {
 					area_enclosed_polygon_list.remove(ci);
@@ -837,8 +829,7 @@
 		// recursive call below
 
-		for (AreaPolygon area_polygon : area_enclosed_polygon_list) {
-
-			Collection<Item> enclosed_items = FrameUtils.getItemsEnclosedBy(
-					frame, area_polygon);
+		for (PolygonBounds area_polygon : area_enclosed_polygon_list) {
+
+			Collection<Item> enclosed_items = FrameUtils.getItemsEnclosedBy(frame, area_polygon);
 			List<Item> enclosed_item_list = new ArrayList<Item>(enclosed_items);
 
@@ -849,5 +840,5 @@
 				// Filter out enclosed-items points that are part of the
 				// polygon's perimeter
-				if (area_polygon.isPerimeterPoint(enclosed_item.getPosition())) {
+				if (area_polygon.isVertex(enclosed_item.getPosition())) {
 					enclosed_item_list.remove(i);
 					// Don't include items the user hasn't asked us to.
@@ -863,6 +854,5 @@
 			// Recursively work on the identified sub-group
 
-			XGroupItem xgroup_item = new XGroupItem(frame, enclosed_item_list,
-					area_polygon);
+			XGroupItem xgroup_item = new XGroupItem(frame, enclosed_item_list, area_polygon);
 
 			grouped_item_list.add(xgroup_item);
Index: /trunk/src/org/expeditee/io/flowlayout/XItem.java
===================================================================
--- /trunk/src/org/expeditee/io/flowlayout/XItem.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/flowlayout/XItem.java	(revision 1102)
@@ -19,12 +19,12 @@
 package org.expeditee.io.flowlayout;
 
-import java.awt.Point;
-import java.awt.Rectangle;
 
+import org.expeditee.core.Point;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
 import org.expeditee.items.Item;
 
 public abstract class XItem 
 {
-	protected Rectangle bounding_rect;
+	protected AxisAlignedBoxBounds bounding_rect;
 		
 	protected XItem()
@@ -33,5 +33,5 @@
 	}
 	
-	protected XItem(Rectangle imprint_bounding_rect)
+	protected XItem(AxisAlignedBoxBounds imprint_bounding_rect)
 	{
 		this.bounding_rect = imprint_bounding_rect;
@@ -40,5 +40,5 @@
 	public int getX()
 	{
-		return bounding_rect.x;
+		return bounding_rect.getMinX();
 	}
 	
@@ -46,10 +46,10 @@
 	{
 		// name alias for getX()
-		return bounding_rect.x;
+		return bounding_rect.getMinX();
 	}
 	
 	public int getY()
 	{
-		return bounding_rect.y;
+		return bounding_rect.getMinY();
 	}
 	
@@ -57,33 +57,33 @@
 	{
 		// name alias for getY()
-		return bounding_rect.y;
+		return bounding_rect.getMinY();
 	}
 	
 	public int getBoundingYBot()
 	{
-		return bounding_rect.y + bounding_rect.height -1;
+		return bounding_rect.getMaxY();
 	}
 	
 	public int getBoundingXRight()
 	{
-		return bounding_rect.x + bounding_rect.width -1;
+		return bounding_rect.getMaxX();
 	}
 	
 	public int getBoundingWidth()
 	{
-		return bounding_rect.width;
+		return bounding_rect.getWidth();
 	}
 	
 	public int getBoundingHeight()
 	{
-		return bounding_rect.height;
+		return bounding_rect.getHeight();
 	}
 	
-	public Rectangle getBoundingRect()
+	public AxisAlignedBoxBounds getBoundingRect()
 	{
 		return bounding_rect;
 	}
 	
-	public Rectangle setBoundingRect(Rectangle rect)
+	public AxisAlignedBoxBounds setBoundingRect(AxisAlignedBoxBounds rect)
 	{
 		return bounding_rect = rect;
Index: /trunk/src/org/expeditee/io/flowlayout/XOrderedLine.java
===================================================================
--- /trunk/src/org/expeditee/io/flowlayout/XOrderedLine.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/flowlayout/XOrderedLine.java	(revision 1102)
@@ -19,7 +19,8 @@
 package org.expeditee.io.flowlayout;
 
-import java.awt.Rectangle;
 import java.util.ArrayList;
 import java.util.List;
+
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
 
 public class XOrderedLine 
@@ -83,6 +84,6 @@
 		{
 			// Simple case => want to insert based on the new_item's xl position
-			Rectangle rect = new_item.getBoundingRect();
-			int xl = rect.x;
+			AxisAlignedBoxBounds rect = new_item.getBoundingRect();
+			int xl = rect.getMinX();
 			orderedMergeItem(xl,new_item);
 		}
Index: /trunk/src/org/expeditee/io/flowlayout/XRawItem.java
===================================================================
--- /trunk/src/org/expeditee/io/flowlayout/XRawItem.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/flowlayout/XRawItem.java	(revision 1102)
@@ -41,5 +41,5 @@
 		else {
 			// Just in case it isn't a text item
-			bounding_rect = item.getArea().getBounds();
+			bounding_rect = item.getBoundingBox();
 		}
 		
Index: /trunk/src/org/expeditee/items/Circle.java
===================================================================
--- /trunk/src/org/expeditee/items/Circle.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/Circle.java	(revision 1102)
@@ -19,11 +19,17 @@
 package org.expeditee.items;
 
-import java.awt.Color;
-import java.awt.Graphics2D;
-import java.awt.Polygon;
-import java.awt.Rectangle;
-import java.awt.geom.Point2D;
 import java.util.Collection;
 import java.util.LinkedList;
+
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Fill;
+import org.expeditee.core.Point;
+import org.expeditee.core.Stroke;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.core.bounds.CombinationBoxBounds;
+import org.expeditee.core.bounds.EllipticalBounds;
+import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.EcosystemManager;
 
 /**
@@ -42,5 +48,6 @@
 	 * @param _source
 	 */
-	public Circle(Text source) {
+	public Circle(Text source)
+	{
 		super(source);
 		// Collection<Item> connected = source.getAllConnected();
@@ -50,5 +57,5 @@
 		_center.addEnclosure(this);
 		_line.setHidden(true);
-		updatePolygon();
+		invalidateBounds();
 	}
 
@@ -87,11 +94,8 @@
 
 	@Override
-	public Polygon getEnclosedShape() {
+	public PolygonBounds getEnclosedShape() {
 		// assert(_poly != null);
 		// Ensure that vector items will gradient fill are painted OK!!
-		if (_poly == null) {
-			updatePolygon();
-		}
-		return _poly;
+		return ((EllipticalBounds) updateBounds()).getPolygon(16);
 	}
 
@@ -138,5 +142,5 @@
 		newCircle._line.setVisible(_line.isVisible());
 		newCircle._source.setVisible(_source.isVisible());
-		newCircle.updatePolygon();
+		newCircle.invalidateBounds();
 		return newCircle;
 	}
@@ -152,9 +156,9 @@
 
 	@Override
-	public boolean contains(int x, int y) {
+	public boolean contains(Point p) {
 		double radius = getRadius();
 
-		double distance = Math.sqrt(Math.pow(Math.abs(_center.getX() - x), 2)
-				+ Math.pow(Math.abs(_center.getY() - y), 2));
+		double distance = Math.sqrt(Math.pow(Math.abs(_center.getX() - p.x), 2)
+				+ Math.pow(Math.abs(_center.getY() - p.y), 2));
 
 		return Math.abs(distance - radius) < getGravity() * 2;
@@ -167,52 +171,40 @@
 	 */
 	@Override
-	public void paint(Graphics2D g) {
+	public void paint() {
 		int radius = (int) Math.round(getRadius());
-		int diameter = radius * 2;
-		Color fillColor = getFillColor();
-		if (fillColor != null) {
-			setFillPaint(g);
-			g.fillOval(_center.getX() - radius, _center.getY() - radius,
-					diameter, diameter);
+		Point centre = new Point(_center.getX(), _center.getY());
+		Dimension diameters = new Dimension(radius * 2, radius * 2);
+		Fill fill = new Fill(getFillColor());
+		Colour lineColour = null;
+		Stroke lineStroke = null;
+		if (isHighlighted()) {
+			lineColour = getHighlightColor();
+			lineStroke = HIGHLIGHT_STROKE;
+		} else if (getThickness() > 0 || getFillColor() == null) {
+			lineColour = getPaintColor();
+			lineStroke = _line.getStroke();
 		}
-		if (getThickness() > 0 || fillColor == null) {
-			Color lineColor = getPaintColor();
-			g.setColor(lineColor);
-			g.setStroke(_line.getStroke());
-			g.drawOval(_center.getX() - radius, _center.getY() - radius,
-					diameter, diameter);
+		
+		EcosystemManager.getGraphicsManager().drawOval(centre, diameters, 0.0f, fill, lineColour, lineStroke);
+		
+		if (isHighlighted()) {
+			_center.paint();
 		}
-		// Arc version, same result but allows for portions of the circle to be
-		// drawn
-		// g.drawArc(end.getX() - (distance / 2), end.getY() - (distance / 2),
-		// distance, distance, 0, 360);
-
-		if (isHighlighted()) {
-			// Flag the background color of the circle so that the item will be
-			// drawn with alternate color if the background is the same as
-			// the highlight}
-			_center.paint(g);
-			Color highlightColor = getHighlightColor();
-			g.setColor(highlightColor);
-			g.setStroke(HIGHLIGHT_STROKE);
-			g.drawOval(_center.getX() - radius, _center.getY() - radius,
-					diameter, diameter);
-		}
-	}
-
-	@Override
-	public void setHighlightMode(HighlightMode mode, Color color) {
-		_center.setHighlightMode(mode, color);
-		super.setHighlightMode(mode, color);
-	}
-
-	@Override
-	public int setHighlightColor(Color c) {
+	}
+
+	@Override
+	public void setHighlightModeAndColour(HighlightMode mode, Colour color) {
+		_center.setHighlightModeAndColour(mode, color);
+		super.setHighlightModeAndColour(mode, color);
+	}
+
+	@Override
+	public void setHighlightColor(Colour c) {
 		_center.setHighlightColor(c);
-		return super.setHighlightColor(c);
-	}
-
-	@Override
-	public void setFillColor(Color c) {
+		/*return*/ super.setHighlightColor(c);
+	}
+
+	@Override
+	public void setFillColor(Colour c) {
 		super.setFillColor(c);
 		_center.setColor(c);
@@ -221,5 +213,5 @@
 
 	@Override
-	public void setGradientColor(Color c) {
+	public void setGradientColor(Colour c) {
 		super.setGradientColor(c);
 		invalidateCommonTrait(ItemAppearence.GradientColor);
@@ -255,22 +247,7 @@
 	 */
 	@Override
-	public void updatePolygon() {
-		double radius = getRadius();
-		// Approximation of circle for mouse interaction
-		int points = 20;
-
-		double radians = 0.0;
-		int xPoints[] = new int[points];
-		int yPoints[] = new int[xPoints.length];
-
-		for (int i = 0; i < xPoints.length; i++) {
-			xPoints[i] = (int) Math.round(radius * Math.cos(radians));
-			yPoints[i] = (int) Math.round(radius * Math.sin(radians));
-			radians += (2.0 * Math.PI) / xPoints.length;
-		}
-
-		_poly = new Polygon(xPoints, yPoints, xPoints.length);
-		_poly.translate(_center.getX(), _center.getY());
-		return;
+	public EllipticalBounds updateBounds()
+	{
+		return new EllipticalBounds(_center.getPosition(), (int) (getRadius() * 2));
 	}
 
@@ -280,9 +257,8 @@
 	}
 
-	/**
-	 * Resizes the circle from the center.
-	 */
-	@Override
-	public void setSize(float size) {
+	/** Resizes the circle from the center. */
+	@Override
+	public void setSize(float size)
+	{
 		double ratio = size / getRadius();
 		
@@ -290,5 +266,5 @@
 		_source.translate(_center.getPosition(), ratio);
 
-		updatePolygon();
+		invalidateBounds();
 	}
 
@@ -303,7 +279,9 @@
 	}
 
-	@Override
-	public void translate(Point2D origin, double ratio) {
-		updatePolygon();
+	// TODO: Why is this commented out? cts16
+	@Override
+	public void translate(Point origin, double ratio)
+	{
+		invalidateBounds();
 		// _center.translate(origin, ratio);
 		// super.translate(origin, ratio);
@@ -311,5 +289,5 @@
 
 	@Override
-	public Rectangle[] getDrawingArea() {
+	public AxisAlignedBoxBounds getDrawingArea() {
 
 		float thickness = getThickness();
@@ -318,7 +296,7 @@
 		int size = (int) ((2 * radius) + 3.0 + thickness);
 
-		return new Rectangle[] { new Rectangle((int) (_center.getX() - radius
+		return new AxisAlignedBoxBounds((int) (_center.getX() - radius
 				- 0.5 - (thickness / 2.0)), (int) (_center.getY() - radius
-				- 0.5 - (thickness / 2.0)), size, size) };
+				- 0.5 - (thickness / 2.0)), size, size);
 	}
 
Index: /trunk/src/org/expeditee/items/Dot.java
===================================================================
--- /trunk/src/org/expeditee/items/Dot.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/Dot.java	(revision 1102)
@@ -19,16 +19,20 @@
 package org.expeditee.items;
 
-import java.awt.Color;
-import java.awt.Graphics2D;
-import java.awt.Polygon;
-import java.awt.Rectangle;
 import java.util.ArrayList;
 import java.util.LinkedList;
 import java.util.List;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Fill;
+import org.expeditee.core.Point;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.core.bounds.Bounds;
+import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
-import org.expeditee.gui.FrameKeyboardActions;
 
 /**
@@ -70,5 +74,5 @@
 
 	@Override
-	public void setColor(Color c) {
+	public void setColor(Colour c) {
 		super.setColor(c);
 
@@ -79,5 +83,5 @@
 
 	@Override
-	public void setAnchorLeft(Float anchor) {
+	public void setAnchorLeft(Integer anchor) {
 		if (!isLineEnd()) {
 			super.setAnchorLeft(anchor);
@@ -88,6 +92,5 @@
 		invalidateCommonTrait(ItemAppearence.PreMoved);
 		
-		this._anchorLeft = anchor;
-		this._anchorRight = null;
+		this._anchoring.setLeftAnchor(anchor);
 		
 		int oldX = getX();
@@ -102,5 +105,5 @@
 
 	@Override
-	public void setAnchorRight(Float anchor) {
+	public void setAnchorRight(Integer anchor) {
 		if (!isLineEnd()) {
 			super.setAnchorRight(anchor);
@@ -110,11 +113,9 @@
 		invalidateCommonTrait(ItemAppearence.PreMoved);
 		
-		this._anchorRight = anchor;
-		this._anchorLeft = null;
+		this._anchoring.setRightAnchor(anchor);
 		
 		int oldX = getX();
 		if (anchor != null) {
-			float deltaX = FrameGraphics.getMaxFrameSize().width - anchor
-					- getBoundsWidth() - oldX;
+			float deltaX = DisplayController.getFramePaintArea().getWidth() - anchor - getBoundsWidth() - oldX;
 
 			anchorConnected(AnchorEdgeType.Right, deltaX);
@@ -126,5 +127,5 @@
 
 	@Override
-	public void setAnchorTop(Float anchor) {
+	public void setAnchorTop(Integer anchor) {
 		if (!isLineEnd()) {
 			super.setAnchorTop(anchor);
@@ -134,6 +135,5 @@
 		invalidateCommonTrait(ItemAppearence.PreMoved);
 		
-		this._anchorTop = anchor;
-		this._anchorBottom = null;
+		this._anchoring.setTopAnchor(anchor);
 		
 		int oldY = getY();
@@ -148,5 +148,5 @@
 
 	@Override
-	public void setAnchorBottom(Float anchor) {
+	public void setAnchorBottom(Integer anchor) {
 		if (!isLineEnd()) {
 			super.setAnchorBottom(anchor);
@@ -156,11 +156,9 @@
 		invalidateCommonTrait(ItemAppearence.PreMoved);
 		
-		this._anchorBottom = anchor;
-		this._anchorTop = null;
+		this._anchoring.setBottomAnchor(anchor);
 		
 		int oldY = getY();
 		if (anchor != null) {
-			float deltaY = FrameGraphics.getMaxFrameSize().height - anchor
-					- getBoundsHeight() - oldY;
+			float deltaY = DisplayController.getFramePaintArea().getHeight() - anchor - getBoundsHeight() - oldY;
 			anchorConnected(AnchorEdgeType.Bottom, deltaY);
 		}
@@ -173,26 +171,22 @@
 
 	@Override
-	public void paint(Graphics2D g) {
+	public void paint() {
+		GraphicsManager g = EcosystemManager.getGraphicsManager();
 		if (isHighlighted() /* && !FreeItems.getInstance().contains(this) */) {
-			Color highlightColor = getHighlightColor();
-			g.setColor(highlightColor);
-			g.setStroke(DOT_STROKE);
+			Colour highlightColor = getHighlightColor();
+			Fill fill = new Fill(highlightColor);
 			// g.setStroke()
 			// Draw the highlighting rectangle surrounding the dot
 			// this is drawn even if its part of a rectangle
 
-			if (isVectorItem())
-				updatePolygon();
-
-			Rectangle rect = getPolygon().getBounds();
-			if (_mode == HighlightMode.Enclosed ||
-			// Make sure single dots are highlighted filled
-					this.getConnected().size() <= 1)
-				g.fillRect(rect.x, rect.y, rect.width, rect.height);
-			else if (_mode == HighlightMode.Connected){
-				g.setStroke(HIGHLIGHT_STROKE);
-				g.drawRect(rect.x, rect.y, rect.width, rect.height);
-			}else if (_mode == HighlightMode.Normal) {
-				g.fillOval(rect.x, rect.y, rect.width, rect.height);
+			if (isVectorItem()) invalidateBounds();
+
+			AxisAlignedBoxBounds bounds = getBoundingBox();
+			if (_highlightMode == HighlightMode.Enclosed || this.getConnected().size() <= 1) { // Make sure single dots are highlighted filled
+				g.drawRectangle(bounds.getTopLeft(), bounds.getSize(), 0.0f, fill, highlightColor, DOT_STROKE, null);
+			} else if (_highlightMode == HighlightMode.Connected) {
+				g.drawRectangle(bounds.getTopLeft(), bounds.getSize(), 0.0f, null, highlightColor, HIGHLIGHT_STROKE, null);
+			} else if (_highlightMode == HighlightMode.Normal) {
+				g.drawOval(bounds.getCentre(), bounds.getSize(), 0.0f, fill, highlightColor, DOT_STROKE);
 			}
 			// System.out.println(_mode.toString());
@@ -200,75 +194,53 @@
 
 		// dots on lines are hidden
-		if (getLines().size() > 0)
-			return;
-
-		g.setColor(getPaintColor());
+		if (getLines().size() > 0) return;
 
 		int thick = (int) getThickness();
-		if (thick < MINIMUM_DOT_SIZE)
-			thick = MINIMUM_DOT_SIZE;
-
-		int width = thick / 2;
-
+		if (thick < MINIMUM_DOT_SIZE) thick = MINIMUM_DOT_SIZE;
+		
+		Fill fill = _filled ? new Fill(getPaintColor()) : null;
+
+		// TODO: On testing, this code doesn't seem to work (can't change to any type except square). cts16
 		switch (_type) {
-		case circle:
-			if (_filled)
-				g.fillOval(getX() - width, getY() - width, thick, thick);
-			else {
-				g.drawOval(getX() - width, getY() - width, thick, thick);
-			}
-			break;
-		case diamond:
-			int[] x = new int[4];
-			int[] y = new int[4];
-
-			x[0] = x[2] = getX();
-			x[1] = getX() - width;
-			x[3] = getX() + width;
-
-			y[1] = y[3] = getY();
-			y[0] = getY() - width;
-			y[2] = getY() + width;
-
-			if (_filled)
-				g.fillPolygon(x, y, 4);
-			else {
-				g.drawPolygon(x, y, 4);
-			}
-			break;
-		case triangle:
-			x = new int[3];
-			y = new int[3];
-
-			x[0] = getX();
-			x[1] = getX() - width;
-			x[2] = getX() + width;
-
-			y[0] = getY() - width;
-			y[1] = y[2] = getY() + width;
-
-			if (_filled)
-				g.fillPolygon(x, y, 3);
-			else {
-				g.drawPolygon(x, y, 3);
-			}
-			break;
-		case roundSquare:
-			int arc = thick / 2;
-			if (_filled)
-				g.fillRoundRect(getX() - width, getY() - width, thick, thick,
-						arc, arc);
-			else {
-				g.drawRoundRect(getX() - width, getY() - width, thick, thick,
-						arc, arc);
-			}
-			break;
-		default:
-			if (_filled)
-				g.fillRect(getX() - width, getY() - width, thick, thick);
-			else {
-				g.drawRect(getX() - width, getY() - width, thick, thick);
-			}
-
+			case circle:
+				g.drawOval(
+						new Point(getX(), getY()),
+						new Dimension(thick, thick),
+						0.0,
+						fill,
+						getPaintColor(),
+						null
+				);
+				break;
+			case diamond:
+				PolygonBounds diamond = PolygonBounds.getDiamond(thick, thick).translate(getX(), getY()).close();
+				g.drawPolygon(diamond, null, null, 0.0, fill, getPaintColor(), null);
+				break;
+			case triangle:
+				PolygonBounds triangle = PolygonBounds.getTriangle(thick, thick).translate(getX(), getY()).close();
+				g.drawPolygon(triangle, null, null, 0.0, fill, getPaintColor(), null);
+				break;
+			case roundSquare:
+				int arc = thick / 4;
+				g.drawRectangle(
+					new Point(getX(), getY()),
+					new Dimension(thick, thick),
+					0.0,
+					fill,
+					getPaintColor(),
+					null,
+					new Dimension(arc, arc)
+				);
+				break;
+			default:
+				g.drawRectangle(
+						new Point(getX(), getY()),
+						new Dimension(thick, thick),
+						0.0,
+						fill,
+						getPaintColor(),
+						null,
+						null
+				);
 		}
 
@@ -276,19 +248,22 @@
 
 	/**
-	 * Updates the points of the polygon surrounding this Dot
+	 * Updates the bounds surrounding this Dot.
+	 * TODO: Standardise Dot minimum size. cts16
 	 */
-	public void updatePolygon() {
+	public Bounds updateBounds()
+	{
 		int thick = Math.round(getThickness());
+		
 		// Sets a minimum size for the dot
 		thick = Math.max(thick, getGravity() * 2);
+		
+		// Include the gravity in the thickness
+		thick += 2 * getGravity();
+		
 
 		int x = getX() - thick / 2;
 		int y = getY() - thick / 2;
-
-		_poly = new Polygon();
-		_poly.addPoint(x - getGravity(), y - getGravity());
-		_poly.addPoint(x + thick + getGravity(), y - getGravity());
-		_poly.addPoint(x + thick + getGravity(), y + thick + getGravity());
-		_poly.addPoint(x - getGravity(), y + thick + getGravity());
+		
+		return new AxisAlignedBoxBounds(x, y, thick, thick);
 	}
 
@@ -303,14 +278,14 @@
 
 	@Override
-	public int setHighlightColor() {
-		super.setHighlightColor();
-
-		return Item.DEFAULT_CURSOR;
+	public void setHighlightColorToDefault() {
+		super.setHighlightColorToDefault();
+
+		//return Item.DEFAULT_CURSOR;
 	}
 
 	@Override
 	public void setAnnotation(boolean val) {
-		DisplayIO.setCursorPosition(this.getPosition());
-		FrameKeyboardActions.replaceDot(this, '@');
+		DisplayController.setCursorPosition(this.getPosition());
+		Item.replaceDot(this, '@');
 	}
 
@@ -406,8 +381,8 @@
 			if (parent != null && parent != current) {
 				this.setParent(parent);
-				if (DisplayIO.getCurrentSide() == 0)
-					this.setX(this.getX() - DisplayIO.getMiddle());
+				if (DisplayController.getCurrentSide() == DisplayController.TwinFramesSide.LEFT)
+					this.setX(this.getX() - DisplayController.getTwinFramesSeparatorX());
 				else
-					this.setX(this.getX() + DisplayIO.getMiddle());
+					this.setX(this.getX() + DisplayController.getTwinFramesSeparatorX());
 			}
 			break;
@@ -420,5 +395,5 @@
 			if (line.getID() < 0 && !current.getItems().contains(line)) {
 				line.setID(current.getNextItemID());
-				line.setHighlightColor();
+				line.setHighlightColorToDefault();
 				// Mike: Why was this line here?
 				// anchor(line);
@@ -436,5 +411,5 @@
 
 	@Override
-	public void lineColorChanged(Color c) {
+	public void lineColorChanged(Colour c) {
 		if (getColor() != c) {
 			setColor(c);
@@ -450,3 +425,9 @@
 		return super.dontSave();
 	}
+
+	@Override
+	public float getSize()
+	{
+		return getThickness();
+	}
 }
Index: /trunk/src/org/expeditee/items/FrameBitmap.java
===================================================================
--- /trunk/src/org/expeditee/items/FrameBitmap.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/FrameBitmap.java	(revision 1102)
@@ -19,10 +19,8 @@
 package org.expeditee.items;
 
-import java.awt.Color;
-import java.awt.Image;
-import java.awt.image.BufferedImage;
-import java.awt.image.ImageObserver;
 import java.util.List;
 
+import org.expeditee.core.Colour;
+import org.expeditee.core.Image;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameIO;
@@ -31,6 +29,6 @@
 
 public class FrameBitmap extends FramePicture {
-	public FrameBitmap(Text source, ImageObserver observer, Image image){
-		super(source, observer, image);
+	public FrameBitmap(Text source, Image image){
+		super(source, image);
 	}
 
@@ -59,10 +57,9 @@
 			return false;
 		
-		BufferedImage bi = new BufferedImage(width, height,
-				BufferedImage.TYPE_INT_ARGB);
+		Image bi = Image.createImage(width, height);
 		// now set the bits on the image
-		final int transparent = (new Color(0F, 0F, 0F, 0F)).getRGB();
-		final int main = _source.getPaintColor().getRGB();
-		final Color c = _source.getPaintColor();
+		final int transparent = (new Colour(0F, 0F, 0F, 0F)).getARGB32BitPacked();
+		final int main = _source.getPaintColor().getARGB32BitPacked();
+		final Colour c = _source.getPaintColor();
 		int currentColor = main;
 		int row = 0;
@@ -74,12 +71,12 @@
 					// Space is transparent as is 0
 					if (Character.isDigit(currentPixel)) {
-						int alpha = Math.round((currentPixel - '0') * 25.5F);
-						currentColor = new Color(c.getRed(), c.getGreen(), c
-								.getBlue(), alpha).getRGB();
+						int alpha = Math.round((currentPixel - '0') * (Colour.COMPONENT_MAX_VALUE / 10.0f));
+						currentColor = new Colour(c.getRed(), c.getGreen(), c
+								.getBlue(), alpha).getARGB32BitPacked();
 					}else if (currentPixel != ' ') {
 						currentColor = main;
 					}
 				}
-				bi.setRGB(i, row, currentColor);
+				bi.setPixel(i, row, Colour.fromARGB32BitPacked(currentColor));
 			}
 			row++;
@@ -92,6 +89,5 @@
 	@Override
 	protected Picture createPicture() {
-		return new FrameBitmap((Text) _source.copy(),
-				_imageObserver, _image);
+		return new FrameBitmap((Text) _source.copy(), _image);
 	}
 
Index: /trunk/src/org/expeditee/items/FrameImage.java
===================================================================
--- /trunk/src/org/expeditee/items/FrameImage.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/FrameImage.java	(revision 1102)
@@ -19,7 +19,5 @@
 package org.expeditee.items;
 
-import java.awt.Image;
-import java.awt.image.ImageObserver;
-
+import org.expeditee.core.Image;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
@@ -41,11 +39,11 @@
 	 *            screen.
 	 */
-	public FrameImage(Text source, ImageObserver observer, Image image) {
-		super(source, observer, image);
+	public FrameImage(Text source, Image image) {
+		super(source, image);
 	}
 
 	@Override
 	protected Picture createPicture() {
-		return new FrameImage(_source.copy(), _imageObserver, _image);
+		return new FrameImage(_source.copy(), _image);
 	}
 
@@ -59,6 +57,5 @@
 			return false;
 
-		frame.setBuffer(null);
-		FrameGraphics.UpdateBuffer(frame, false, false);
+		frame.setBuffer(FrameGraphics.getFrameImage(frame, null, null, false, false));
 		_image = frame.getBuffer();
 
@@ -66,5 +63,5 @@
 		// been created to begin with
 		parseSize();
-		updatePolygon();
+		invalidateBounds();
 		return true;
 	}
